package xyz.matj1.bp;

import xyz.matj1.bp.enums.MocapType;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Arrays;
import java.util.Map;
import java.util.Map.Entry;
import java.util.stream.Collectors;

public class CacheInspection {
	public static void main(String[] args) throws Exception {
		var deserialiser = new ObjectInputStream(new FileInputStream("cache/knnTestsAveragedOrderedToGraphs"));
		var typeDataset = (Map<MocapType, double[][]>)deserialiser.readObject();

		typeDataset.forEach((type, arrays) -> {
			System.out.println(type.noun());
			for (var array : arrays) {
				System.out.println(Arrays.toString(array));
			}
			System.out.println();
		});

		var switchedArrays = typeDataset.entrySet().stream().collect(Collectors.toUnmodifiableMap(
			Entry::getKey,
			entry -> {
				var arrays = entry.getValue();
				return new double[][] {arrays[1], arrays[0]};
		}));

		var serialiser = new ObjectOutputStream(new FileOutputStream("cache/knnTestsAveragedOrderedToGraphs"));
		serialiser.writeObject(switchedArrays);


	}
}
