package xyz.matj1.bp;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

public class Config {
	private static final Properties properties = properties();

	public static Theme graphTheme() {
		if (properties.getProperty("graphTheme", "").equals("dark")) {
			return Theme.DARK;
		} else {
			return Theme.LIGHT;
	}}

	public static File outputDir() {
		var outputDir = properties.getProperty("outputDir");
		return new File(outputDir == null ? "output" : outputDir);
	}

	public static File cacheDir() {
		var cacheDir = properties.getProperty("cacheDir");
		return new File(cacheDir == null ? "cache" : cacheDir);
	}

	public static File dataDir() {
		var dataDir = properties.getProperty("dataDir");
		return new File(dataDir == null ? "data" : dataDir);
	}

	private static Properties properties() {
		var properties = new Properties();
		try (var propsFile = new FileInputStream("resources/config.properties")) {
			properties.load(propsFile);
		} catch (IOException e) {
			System.err.println("The configuration file wasn't loaded because of " + e);
		}

		return properties;
	}

	public enum Theme {
		LIGHT,
		DARK,
	}
}
