package xyz.matj1.bp.enums;

import xyz.matj1.bp.Utils;

/**
 * The constants of this represent multiples of speeds of motion-capture data used in this project.
 */
public enum SpeedMultiple {
	_1_4(1/4d),
	_1_2(1/2d),
	_2_3(2/3d),
	_1(1d),
	_3_2(3/2d),
	_2(2d),
	_4(4d),
	;

	private final Double asDouble;

	SpeedMultiple(Double asDouble) {
		this.asDouble = asDouble;
	}

	/**
	 * @return the value represented by the constant
	 */
	public Double asDouble() {
		return asDouble;
	}

	/**
	 * This rounds the value to 2 decimal places and converts it to a string
	 * in a way that there are no trailing zeroes and “.” is used as the decimal separator.
	 *
	 * @return a text representation of the value represented by the constant
	 */
	public String asString() {
		return Utils.displayDouble(this.asDouble, 2);
	}

	@Override
	public String toString() {
		return this.asString();
	}
}
