package xyz.matj1.bp.themes;

import org.jfree.chart.ChartTheme;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.StandardChartTheme;
import org.jfree.chart.ui.RectangleInsets;
import xyz.matj1.bp.Config;
import xyz.matj1.bp.Config.Theme;

import java.awt.Color;

public class XyGraphTheme implements ChartTheme {
	private static final XyGraphTheme instance = new XyGraphTheme();

	protected XyGraphTheme() {}

	@Override
	public void apply(JFreeChart chart) {
		chart.setPadding(RectangleInsets.ZERO_INSETS);
		chart.getPlot().setBackgroundPaint(Color.WHITE);
		chart.setBorderVisible(false);

		if (Config.graphTheme().equals(Theme.DARK)) {
			StandardChartTheme.createDarknessTheme().apply(chart);
	}}

	public static XyGraphTheme instance() {
		return instance;
	}
}
